/***************************************************************************
 *   Copyright (C) 2005 by yunfan                                          *
 *   yunfan_zg@163.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIBEVALOGINTOKEN_H
#define LIBEVALOGINTOKEN_H

#include "evapacket.h" 
class RequestLoginTokenPacket : public OutPacket{
public:
	RequestLoginTokenPacket();
	RequestLoginTokenPacket(const RequestLoginTokenPacket &);
	virtual ~RequestLoginTokenPacket(){};
	
	OutPacket * copy() { return new RequestLoginTokenPacket(*this);}
	RequestLoginTokenPacket &operator=(const RequestLoginTokenPacket &rhs);
protected:
	virtual int putBody(unsigned char *buf);
};

class RequestLoginTokenReplyPacket : public InPacket {
public:
	RequestLoginTokenReplyPacket();
	RequestLoginTokenReplyPacket(unsigned char *buf, int len) ;  
	RequestLoginTokenReplyPacket(const RequestLoginTokenReplyPacket &rhs);
	virtual ~RequestLoginTokenReplyPacket();
	
	InPacket * copy() { return new RequestLoginTokenReplyPacket(*this);}
	RequestLoginTokenReplyPacket &operator=(const RequestLoginTokenReplyPacket &rhs);
	
	const int getTokenLength() const { return length; }
	const unsigned char *getToken() const { return token; }
	
	const bool isReplyOk() const ;
	const char getReplyCode() const { return replyCode; }
protected:
	virtual void parseBody();
private:
	char replyCode;
	int length;
	unsigned char *token;
};

#endif
